//GDSIIExporter.pas
//Copyright  2001-2005 Easy Math Solution. All Rights Reserved
//http://www.e-MathSolution.com
//For details contact us: info@e-MathSolution.com


unit GDSIIExporter;

interface
uses
  SysUtils;


type
        p__int32 =^Longint;
        __int16 =  Smallint;
        __int32 =  Longint;
        TCHAR   =  PChar;
        TpFuncError=^TFuncErr;
        TFuncErr=procedure(er:string);

//Interface of GDSIIExporter.dll
procedure GDS_Path(pointsX:p__int32; pointsY:p__int32; pointsNum:__int16;
        	width:__int32; layer:__int16; datatype:__int16;
		pathtype:__int16; elflags:__int16; plex:__int32 );stdcall;
procedure GDS_Boundary(pointsX:p__int32; pointsY:p__int32; pNum:__int16;
			layer:__int16; datatype:__int16; elflags:__int16;
			plex:__int32 ); stdcall;
procedure GDS_Circle(centerX:__int32; centerY:__int32; radius:__int32;
        		segmentNum:__int16; layer:__int16; datatype:__int16;
			elflags:__int16; plex:__int32 );stdcall;
procedure GDS_Arc(centerX:__int32; centerY:__int32; radius:__int32;
		startAng:double; endAng:double; segmentNum:__int16;
		width:__int32; layer:__int16; datatype:__int16;
		pathtype:__int16; elflags:__int16; plex:__int32 );stdcall;
procedure GDS_Sector(centerX:__int32; centerY:__int32; radius:__int32;
		startAng:double; endAng:double; segmentNum:__int16;
		layer:__int16; datatype:__int16; elflags:__int16;
					  	plex:__int32 );stdcall;
procedure GDS_BoxWH(x:__int32; y:__int32; width:__int32; height:__int32;
        	     layer:__int16; boxtype:__int16;
		       elflags:__int16; plex:__int32 ); stdcall;
procedure GDS_Box(x1:__int32; y1:__int32; x2:__int32; y2:__int32;
        	        layer:__int16; boxtype:__int16;
		       elflags:__int16; plex:__int32 ); stdcall;
procedure GDS_Square(x1:__int32; y1:__int32; side:__int32;
		      layer:__int16; boxtype:__int16;
                       elflags:__int16; plex:__int32 );stdcall;
procedure GDS_Sref(strName:TCHAR; x:__int32; y:__int32;
		strans:__int16; mag:double; angle:double;
		  elflags:__int16; plex:__int32 ); stdcall;
procedure GDS_Aref(strName:TCHAR; x:p__int32; y:p__int32;
		col:__int16; row:__int16; strans:__int16; mag:double;
		angle:double; elflags:__int16; plex:__int32 );stdcall;
procedure GDS_BeginStructure(strName:TCHAR); stdcall;
procedure GDS_EndStructure;stdcall;
procedure GDS_BeginLib(fileName:TCHAR; dbUserUnit:double;
                                        dbUnitInMeter:double );stdcall;
procedure GDS_EndLib;stdcall;
procedure GDS_Text(pointsX:__int32; pointsY:__int32;  msg:TCHAR;
		   layer:__int16; txtType:__int16; presentation:__int16;
		pathtype:__int16; width:__int32; strans:__int16;
		mag:double; angle:double; elflags:__int16;
				   	       plex:__int32 );stdcall;
procedure GDS_Node(pointsX:p__int32; pointsY:p__int32; pointsNum:__int16;
		layer:__int16; nodeType:__int16; elflags:__int16 ;
                plex:__int32 );stdcall;
procedure SetErrorHandle(errF:TpFuncError);stdcall;


const//////////////////////////////////////////////////
//Presentation bits
//Horizontal justification
PRESENT_HLEFT: word =$0;
PRESENT_HCENTER: word =$1;
PRESENT_HRIGHT: word =$2;

//Vertical justification
PRESENT_VTOP: word =$0;
PRESENT_VMIDDLE: word =$4;
PRESENT_VBOTTOM: word =$8;

//Font number
PRESENT_FONT0: word =$0;
PRESENT_FONT1: word =$10;
PRESENT_FONT2: word =$20;
PRESENT_FONT3: word =$30;


///////////////////////////////////////////////////////////////////////
// PATHTYPE
PATHTYPE0: word =0;
PATHTYPE1: word =1;
PATHTYPE2: word =2;
PATHTYPE4: word =4;


///////////////////////////////////////////////////////////////////////
//ELFLAGS
ELFLAGS_0: word =0;
ELFLAGS_TEMPLATE: word =1;
ELFLAGS_EXTERIOR: word =2;

///////////////////////////////////////////////////////////////////////
//STRANS
STRANS_0: word =0;
STRANS_ABSMAG: word =$4;
STRANS_ABSANG: word =$2;
STRANS_REFLECT: Word    =$8000;

///////////////////////////////////////////////////////////////////////
//PLEX
PLEX_HEAD: __int32 =$1000000;


implementation

procedure GDS_Path; external 'GDSIIExporter.dll';
procedure GDS_Boundary; external 'GDSIIExporter.dll';
procedure GDS_Circle; external 'GDSIIExporter.dll';
procedure GDS_Arc; external 'GDSIIExporter.dll';
procedure GDS_Sector; external 'GDSIIExporter.dll';
procedure GDS_BoxWH; external 'GDSIIExporter.dll';
procedure GDS_Box; external 'GDSIIExporter.dll';
procedure GDS_Square; external 'GDSIIExporter.dll';
procedure GDS_Sref; external 'GDSIIExporter.dll';
procedure GDS_Aref; external 'GDSIIExporter.dll';
procedure GDS_BeginStructure; external 'GDSIIExporter.dll';
procedure GDS_EndStructure; external 'GDSIIExporter.dll';
procedure GDS_BeginLib; external 'GDSIIExporter.dll';
procedure GDS_EndLib; external 'GDSIIExporter.dll';
procedure GDS_Text; external 'GDSIIExporter.dll';
procedure GDS_Node; external 'GDSIIExporter.dll';
procedure SetErrorHandle; external 'GDSIIExporter.dll';



//Native function to raise exception
procedure RiaseException(err:PChar);stdcall;
begin
        raise   Exception.Create(err);
end;


initialization
        //Init the error handle
        SetErrorHandle( @RiaseException );
end.

